# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup


# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
package_name = "seadrive-gui"


def update_package():
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://manual.seafile.com/changelog/drive-client-changelog/"
    version = control.get_software_version()

    """ for u in bs_find_all(url,'li', proxies=proxies):
    # Getting latest version from official website
    #for u in bs_find_all(url,'h3', proxies=proxies):
        if '[Linux]' in u.text:
            previous_element = u.previous_element
            good_version = False
            while(not good_version):
                if previous_element.name =='h3':
                    latest_version = previous_element.text.split(' ')[0]
                    good_version=True
                else:
                    previous_element = previous_element.previous_element

    import requests
    page = requests.get(url, proxies=proxies).text
    soup = BeautifulSoup.BeautifulSoup(page)
    soup.find_all('h3')

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url) """

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return result
